import { getEndpointPlugin } from "@aws-sdk/middleware-endpoint";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetSMSSandboxAccountStatusInputFilterSensitiveLog, GetSMSSandboxAccountStatusResultFilterSensitiveLog, } from "../models/models_0";
import { deserializeAws_queryGetSMSSandboxAccountStatusCommand, serializeAws_queryGetSMSSandboxAccountStatusCommand, } from "../protocols/Aws_query";
export class GetSMSSandboxAccountStatusCommand extends $Command {
    constructor(input) {
        super();
        this.input = input;
    }
    static getEndpointParameterInstructions() {
        return {
            UseFIPS: { type: "builtInParams", name: "useFipsEndpoint" },
            Endpoint: { type: "builtInParams", name: "endpoint" },
            Region: { type: "builtInParams", name: "region" },
            UseDualStack: { type: "builtInParams", name: "useDualstackEndpoint" },
        };
    }
    resolveMiddleware(clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        this.middlewareStack.use(getEndpointPlugin(configuration, GetSMSSandboxAccountStatusCommand.getEndpointParameterInstructions()));
        const stack = clientStack.concat(this.middlewareStack);
        const { logger } = configuration;
        const clientName = "SNSClient";
        const commandName = "GetSMSSandboxAccountStatusCommand";
        const handlerExecutionContext = {
            logger,
            clientName,
            commandName,
            inputFilterSensitiveLog: GetSMSSandboxAccountStatusInputFilterSensitiveLog,
            outputFilterSensitiveLog: GetSMSSandboxAccountStatusResultFilterSensitiveLog,
        };
        const { requestHandler } = configuration;
        return stack.resolve((request) => requestHandler.handle(request.request, options || {}), handlerExecutionContext);
    }
    serialize(input, context) {
        return serializeAws_queryGetSMSSandboxAccountStatusCommand(input, context);
    }
    deserialize(output, context) {
        return deserializeAws_queryGetSMSSandboxAccountStatusCommand(output, context);
    }
}
